/*          $VER: MergeAIFF 1.0 (9.1.98)
**       Started: 980102
**      Location: Waratah.au
**    Last drunk: 3 days ago
**   Last stoned: 12 days ago (H)
**          Mood: Homesick
** Todays wishes: 1> Score 2> Get stoned 3> Return to Sweden
**       Changed: 980105, 980106, 980107, 980108
** 
**  ::::::.::::::. :::::::.   .::  ::::::. .::::.  :::
**  .::.::'.::..:: .::..::' ...`::..::..'' .::.    `' 
**  :::    :::: ::::::: `::.::::::'::::.::.::::::' :::  Captain's log...
**
** 980102:2255 (001) Made some short routines to open the specified files and check if the
**             first bytes are 'FORM'.
** 980105:1908 (001) Scrapped above mentioned routines. Of course I am to use IffParse!
**             Studied iff-parse docs. Hmm...
** 980105:2322 (002) Managed to get iff-parse to read the COMM chunk and put the results
**             in a comm-structure that I copied after the AIFF doc.
** 980106:0110 (002) Now this is stored in the destination (with size = the sum of the sizes
**             of source a and b), but thereafter I cannot find the SSND chunk in the
**             source file.
** 980106:0708 (002) Fixed this problem by using StopChunks() instead. Made the first
**             successfull merge! Now let's see if it can merge files larger than the
**             available memory...
** 980106:0735 (002) No problems! It only seem to use the buffer's memory. I'm trying now
**             to have the buffersize = AvailMem(Largest).
** 980106:1112 (003) Made a very primitive progress indicator. Using a buffersize of 75% of
**             the largest available memoryblock now. I am going to try to implement several
**             sourcefiles now (more than 2).
** 980106:1245 (004) Implemented this, but haven't got it to compile yet. Changed the name
**             from MergeAIFF to JoinAIFF. Like the c:Join an 'as' is required before the
**             destination filename.
** 980107:2355 (005) Everything works ok now. 75% of the largest available memoryblock will
**             now be adjusted after the largest file. But I'm going to remove this, there's
**             no reason to use such a large buffer. Can't remember why I did so in the first
**             place.
** 980108:1502 (005) Now I'm using a buffersize of 256kb. If the allocation fails, the buffer-
**             size will be halved, and a new try made. This continues until success, or until
**             the buffersize gets too small. Perfected the progress-indicator.
** 980108:1737 (005) A destination will no longer be overwritten if it already exists.
** 980109:0040 (005) I am going to upload v1.0 to AmiNet now.
** 980109:0104 (005) Sigh. There was already a program there called JoinAIFF. Changed the
**             name back again to MergeAIFF. (JoinAIFF only joins 2 mono to one stereo).
*/

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <exec/exec.h>
#include <clib/exec_protos.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>
#include <libraries/iffparse.h>
#include <clib/iffparse_protos.h>

#define MAXSRC 20
#define	ID_AIFF	MAKE_ID('A','I','F','F')
#define	ID_COMM	MAKE_ID('C','O','M','M')
#define	ID_SSND	MAKE_ID('S','S','N','D')

const char versiontag[] = "\0$VER: MergeAIFF 1.0 (9.1.98)";
const char *ja_Banner = "\e[33;1mMergeAIFF 1.0\e[31;0m - By \e[1mParsec\e[0m/Phuture303 1998\n";
const char *ja_Template = "Usage: MergeAIFF <source 1> <source 2> [<source 3..20>] AS <output>\n";
const char *Err_IFFHds = "Couldn't allocate IFF handlers.\n";
const char *Err_NoCOMM = "does not seem to contain a COMM chunk.\n";
const char *Err_NoSSND = "does not seem to contain a SSND chunk.\n";
const char *Err_Error = "Error!\n";

/* Text error messages for possible IFFERR_#? returns from various
** IFF routines.  To get the index into this array, take your IFFERR code,
** negate it, and subtract one. idx = -error - 1 */
const char *ErrorMsgs[] = {
      "End of file (not an error).\n",
      "End of context (not an error).\n",
      "No lexical scope.\n",
      "Insufficient memory.\n",
      "Stream read error.\n",
      "Stream write error.\n",
      "Stream seek error.\n",
      "File is corrupt.\n",
      "IFF syntax error.\n",
      "Not an IFF file.\n",
      "Required call-back hook missing.\n",
      "Return to client.  You should never see this.\n" };

struct CommonChunk
       {
       UWORD  numChannels;
       ULONG  numSampleFrames;
       WORD   sampleSize;
       BYTE   sampleRate[10];
       }      comms[MAXSRC], commd;

struct SoundDataChunk
       {
       ULONG  offset;
       ULONG  blockSize;
       }      ssnds[MAXSRC], ssndd;


void ja_CopySSND(struct IFFHandle *iff, struct CommonChunk *comm, const char *filename);
void ja_CleanUp(void);
void ja_Exit(const char *ErrorSpec, const char *ErrorMsg, const int ErrorCode);
void ja_Exit(const char *ErrorMsg, const int ErrorCode);
void ja_Exit(const int ErrorCode);
void ja_FreeIFF(struct IFFHandle *&iff);
void CheckBreak(void);

struct IFFHandle *iffs[MAXSRC], *iffd = NULL;
struct ContextNode *cns[MAXSRC], *cnd;

APTR buffer;
ULONG buffsize = 256000, progr = 0;
LONG error = 0, rlen = 0;
int sources;
UWORD *ja_SamplePtr;

int main(int argc, char **argv)
    {
    LONG stopchks[] = {ID_AIFF, ID_COMM, ID_AIFF, ID_SSND};
    int n;
    sources = argc - 3;

    printf("%s", ja_Banner);
    for (n = 0; n < MAXSRC; n++) {iffs[n] = NULL;}
    if (argc < 4 || argc > MAXSRC+3 || !argv[argc-2][0])
       {
       ja_Exit(ja_Template, 10);
       }
    argv[argc-2][0] = tolower(argv[argc-2][0]);
    argv[argc-2][1] = tolower(argv[argc-2][1]);
    if (strcmp(argv[argc-2], "as"))
       {
       ja_Exit(ja_Template, 10);
       }

    for (n=0; n<sources; n++)       /* Open all given files and allocate an */
        {                               /* IFF-structure for them. */
        if (!(iffs[n] = AllocIFF()))
           {
           ja_Exit(Err_IFFHds, 20);
           }
        if (!(iffs[n]->iff_Stream = Open(argv[n+1], MODE_OLDFILE)))
           {
           ja_Exit(argv[n+1], "could not be opened for input.\n", 20);
           }
        } // for

    while (!buffer && buffsize > 20000)      /* Allocate the copy buffer */
          {
          if (!(buffer = AllocMem(buffsize, 0)))
             {
             buffsize /= 2;
             }
          } // while
    if (!buffer)
       {
       ja_Exit("Couldn't allocate the minimium buffersize of 20kb.\n", 10);
       }
     printf("Using a buffersize of %d bytes.\n", buffsize);


    if (!(iffd = AllocIFF()))                  /* Open the output file */
       {
       ja_Exit(Err_IFFHds, 20);
       }
    if (iffd->iff_Stream = Open(argv[argc-1], MODE_OLDFILE))
       {
       ja_Exit(argv[argc-1], "already exists!\n", 20);
       }
    if (!(iffd->iff_Stream = Open(argv[argc-1], MODE_NEWFILE)))
       {
       ja_Exit(argv[argc-1], "could not be opened for output.\n", 20);
       }

    for (n=0; n<sources; n++)           /* Find the sourcefiles' COMM chunks */
        {
        InitIFFasDOS(iffs[n]);
        if (error = OpenIFF (iffs[n], IFFF_READ))
           {
           ja_Exit(argv[n+1], "failed on OpenIFF for read.\n", 20);
           }
        if (error = StopChunks(iffs[n], stopchks, 2))   // Stop at COMM or SSND chunks
           {
           ja_Exit(argv[n+1], "failed on StopChunks.\n", 20);
           }
        if (error = ParseIFF(iffs[n], IFFPARSE_SCAN))      // Find the COMM chunk...
           {
           ja_Exit(argv[n+1], Err_NoCOMM, 20);
           }
        cns[n] = CurrentChunk(iffs[n]);
        if ((cns[n]) && (cns[n]->cn_Type == ID_AIFF) && (cns[n]->cn_ID == ID_COMM))
           {
           if ((rlen = ReadChunkBytes(iffs[n], &comms[n], sizeof(CommonChunk))) <= 0)
              {
              error = rlen;
              ja_Exit(argv[n+1], "seem to have a corrupted COMM chunk.\n", 20);
              } // if
           } // if
        else
           {
           ja_Exit(argv[n+1], Err_NoCOMM, 20);
           }
        } // for


    for (n=1; n<sources; n++)              /* Check that the samples geometries match */
        {
        if (comms[n].numChannels != comms[0].numChannels)
           {
           ja_Exit(argv[n+1], "does not have the same number of channels as the first source.\n", 10);
           }
        if (comms[n].sampleSize != comms[0].sampleSize)
           {
           ja_Exit(argv[n+1], "Is not sampled with the same amount of bits as the first source.\n", 10);
           }
        } // for


    InitIFFasDOS(iffd);                           /* Store the FORM and COMM chunks */
    if (error = OpenIFF (iffd, IFFF_WRITE))
       {
       ja_Exit("OpenIFF for write on destination failed.\n", 20);
       }
    if (!(error=PushChunk(iffd, ID_AIFF, ID_FORM, IFFSIZE_UNKNOWN)))
       {
       if (!(error=PushChunk(iffd, 0, ID_COMM, IFFSIZE_UNKNOWN)))
          {
          commd = comms[0];                                // Source a's COMM chunk => dest
          for (n=1; n<sources; n++)
              {
              commd.numSampleFrames += comms[n].numSampleFrames;  // Add sampleframe sizes
              }
          if (WriteChunkBytes(iffd, &commd, sizeof(CommonChunk)) != sizeof(CommonChunk))
             {
             error = IFFERR_WRITE;
             }
          } // if
       if (!error)
          {
          error = PopChunk(iffd);
          }
       } // if
    if (error)
       {
       ja_Exit("Error writing COMM data to destination.\n", 20);
       }

    
    for (n=0; n<sources; n++)                /* Find the SSND chunk in all sources */
        {
        if (error = StopChunks(iffs[n], stopchks, 2))   // Stop at COMM or SSND chunks
           {
           ja_Exit(argv[n+1], "failed on StopChunks.\n", 20);
           }
        if (error = ParseIFF(iffs[n], IFFPARSE_SCAN))       // Find the SSND chunk...
           {
           ja_Exit(argv[n+1], Err_NoSSND, 20);
           }
        cns[n] = CurrentChunk(iffs[n]);
        if ((cns[n]) && (cns[n]->cn_Type == ID_AIFF) && (cns[n]->cn_ID == ID_SSND))
           {
           if ((rlen = ReadChunkBytes(iffs[n], &ssnds[n], sizeof(SoundDataChunk))) <= 0)
              {
              error = rlen;
              ja_Exit(argv[n+1], "seem to have a corrupted COMM chunk.\n", 20);
              } // if
           if (ssnds[n].offset || ssnds[n].blockSize)  // Blocksize & Offset must not be used
              {
              ja_Exit(argv[n+1], "has blocksize or offset set to non-zero.\n",10);
              }
           }
        else
           {
           ja_Exit(argv[n+1], Err_NoSSND, 20);
           }
        } // for
    ssndd = ssnds[0];

    if (!(error=PushChunk(iffd, 0, ID_SSND, IFFSIZE_UNKNOWN)))   /* Store the SSND chunk */
       {
       if (WriteChunkBytes(iffd, &ssndd, sizeof(SoundDataChunk)) != sizeof(SoundDataChunk))
          {
          error = IFFERR_WRITE;
          }
       } // if
    if (error)
       {
       ja_Exit("Error writing SSND data to destination.\n", 20);
       }
    for (n=0; n<sources; n++)
        {
        ja_CopySSND(iffs[n], &comms[n], argv[n+1]);
        }

    if (error = PopChunk(iffd))
       {
       ja_Exit(20);
       }
    printf("%d files successfully merged.\n", sources);
    ja_Exit(0);
    } // main


void ja_CopySSND(struct IFFHandle *iff, struct CommonChunk *comm, const char *filename)
     {
     ULONG size = ((comm->sampleSize + 7) / 8) * comm->numChannels * comm->numSampleFrames;
     UBYTE skipchars = (size<10 ? 1 : size<100 ? 2 : size<1000 ? 3 : size<10000 ? 4 : size<100000 ? 5 : size<1000000 ? 6 : size<10000000 ? 7 : size<100000000 ? 8 : size<1000000000 ? 9 : 10) + strlen(filename) + 9;

     rlen = 1;
     progr = 0;
     printf("Reading (%d) %s %%0\r", size, filename);
     while (rlen > 0)
           {
           printf("Read\e[%dC%d\r", skipchars, (100 * progr) / size);
           fflush(stdout);
           CheckBreak();
           if ((rlen = ReadChunkBytes(iff, buffer, buffsize)) > 0)
              {
              printf("Writ\e[%dC%d\r", skipchars, (100 * (progr + rlen/2)) / size);
              fflush(stdout);
              CheckBreak();
              if (WriteChunkBytes(iffd, buffer, rlen) != rlen)
                 {
                 error = IFFERR_WRITE;
                 ja_Exit("\n", Err_Error, 20);
                 } // if
              progr += rlen;
              } // if
           } // while
     if (rlen < 0 && rlen != IFFERR_EOF)
        {
        error = rlen;
        ja_Exit("\n", Err_Error, 20);
        } // if
     printf(" Merged\e[%dC100\n", skipchars-3);
     } // CopySSND

void CheckBreak(void)                     /* Check if CTRL-C is pressed */
     {
     if (SetSignal(0L,SIGBREAKF_CTRL_C) & SIGBREAKF_CTRL_C)
	{
	ja_Exit("\n***Break\n", 10);
	}
     } // CheckBreak

void ja_Exit(const char *ErrorSpec, const char *ErrorMsg, const int ErrorCode)
     {
     printf("%s ", ErrorSpec);
     ja_Exit(ErrorMsg, ErrorCode);
     } // Exit

void ja_Exit(const char *ErrorMsg, const int ErrorCode)
     {
     printf("%s", ErrorMsg);
     ja_Exit(ErrorCode);
     } // Exit

void ja_Exit(const int ErrorCode)
     {
     if (error)
        {
        printf("IFFParse error: %s", ErrorMsgs[-error-1]);
        }
     ja_CleanUp();
     exit(ErrorCode);
     } // Exit

void ja_CleanUp(void)
     {
     ja_FreeIFF(iffd);
     for (int n=0; n<sources; n++)
         {
         ja_FreeIFF(iffs[n]);
         }
     if (buffer)
        {
        FreeMem(buffer, buffsize);
        buffer = NULL;
        } // if
     } // CleanUp

void ja_FreeIFF(struct IFFHandle *&iff)  // Takes a reference to an iff-structure
     {
     if (iff)
        {
        CloseIFF(iff);
        if (iff->iff_Stream)
           {
           Close(iff->iff_Stream);
           iff->iff_Stream = NULL;
           }
        FreeIFF(iff);
        iff = NULL;
        } // if
     } // FreeIFF

